<?php


namespace OrganizationsManagement\Repository;


use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class OqueHaDeNovo
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * Classification constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findItemProduct($dtfiltroitemString, $conditionsQuery, $assuntoIdString)
    {
        $query = <<<SQL
            SELECT * FROM (
            SELECT 'P_' || P.ID AS TREE_ID, P.NMPRODUTO AS NAME, NULL AS PARENT, NULL AS ID, P.ID AS PRODUTO_ID, NULL AS PAI_ID, 
            'Y' AS IS_PRODUCT, 'S' AS IDATIVO, NULL AS DTFILTROITEM
            FROM OM_PRODUTO P
            JOIN PRODUCT PRO ON PRO.ID = P.NREXTERNAL_PRODUCT_ID
            JOIN PROJECT PRJ ON PRJ.ID = PRO.PROJECT_ID AND PRODUCT_TYPE = 'C'
            UNION ALL
            SELECT 'T_' || T.ID AS  TREE_ID, T.DSASSUNTO AS NAME, NVL2(TO_CHAR(T.PAI_ID),'T_' || T.PAI_ID, 'P_' || T.PRODUTO_ID) AS PARENT,
            T.ID, T.PRODUTO_ID, T.PAI_ID, 'N' AS IS_PRODUCT, T.IDATIVO, T.DTFILTROITEM
            FROM OM_OQA_ITEM T
            WHERE 1=1 
            $dtfiltroitemString
            $conditionsQuery
            $assuntoIdString )
            WHERE IDATIVO = 'S'
SQL;
        $result =  $this->entityManager->getConnection()->fetchAll($query);
        $total = count($result);
        $returnNext = [ 'data' => $result, 'pagination' => [ 'limit' => $total, 'page' => 1, 'total' => $total]];
        return $returnNext;
    }

    public function findOmProduct()
    {
        $query = <<<SQL
            SELECT P.ID, P.NMPRODUTO 
            FROM OM_PRODUTO P
            JOIN PRODUCT PRO ON PRO.ID = P.NREXTERNAL_PRODUCT_ID
            JOIN PROJECT PRJ ON PRJ.ID = PRO.PROJECT_ID AND PRODUCT_TYPE = 'C'
            WHERE IDSTATUS = 'A'
SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }

    public function findTreeGridItem($fetchOnDemand, $fetchOnDemandPrimeiraLinha)
    {
        $query = <<<SQL
            SELECT ID, DSASSUNTO, PAI_ID
            FROM OM_OQA_ITEM
            WHERE IDATIVO = 'S'
            $fetchOnDemand
            $fetchOnDemandPrimeiraLinha

SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }
}
